﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.SAAS.KitChenManageOrder.Application.Service.Order.Dtos
{
    public class OrderViewDto
    {
        public string Id { get; set; }
        /// <summary> 
        ///场景id
        /// </summary> 
        public string StoreId { get; set; }
        /// <summary>
        /// 平台订单号
        /// </summary>
        public string OrderNumber { get; set; }
        /// <summary> 
        /// 商户订单号,由商家自定义
        /// </summary> 
        public string TradeNo { get; set; }
        /// <summary> 
        /// 订单状态 0成功,1失败
        /// </summary> 
        public int OrderStatus { get; set; }
        /// <summary> 
        /// 订单总金额
        /// </summary> 
        public decimal TotalAmount { get; set; }
        /// <summary>   
        /// 订单数量 
        /// </summary> 
        public int OrderCount { get; set; }
        /// <summary> 
        /// 订单标题 
        /// </summary> 
        public string Subject { get; set; }
        public DateTime CreatedAt { get; set; }
        public List<OrderdetaiViewDto> Orderdetail { get; set; }
    }
    public class OrderdetaiViewDto
    {
        public string Id { get; set; }
        /// <summary> 
        /// 主订单表Id 
        /// </summary> 
        public string OrderId { get; set; }
        public string GoodsNumber { get; set; }
        public string GoodsId { get; set; }
        public string GoodsName { get; set; }
        public List<GoodsAttrViewDto> GoodsAttr { get; set; }
        /// <summary>
        /// 是否自定义配方
        /// </summary>
        public bool isCustom { get; set; }
        /// <summary>
        /// 工艺配方详情
        /// </summary>
        public List<FormulaDetailViewDto> FormulaDetail { get; set; }
    }
    public class GoodsAttrViewDto
    {
        public string Id { get; set; }
        public string GoodsId { get; set; }
        public string SuborderId { get; set; }
        public string AttributeId { get; set; }
        public string AttributeName { get; set; }
        public int Count { get; set; }
        public decimal Price { get; set; }
    }
    public class FormulaDetailViewDto
    {
        public string Id { get; set; }
        public string SuborderId { get; set; }
        public string DeviceId { get; set; }
        public string GoodsId { get; set; }
        public string TechnologyId { get; set; }
        public string ActionName { get; set; }
        public string ActionValue { get; set; }
        public int Sort { get; set; }
    }
}
