﻿using BPA.SAAS.KitChenManageOrder.Application.Service.ThirdAuthorize;
using BPA.SAAS.KitChenManageOrder.Core;
using BPA.SAAS.KitChenManageOrder.Core.Common;
using BPA.SAAS.KitChenManageOrder.Web.Core.Handlers.Dto;
using Furion;
using Furion.DataEncryption;
using Furion.FriendlyException;
using Furion.RemoteRequest.Extensions;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CurrentUser = BPA.SAAS.KitChenManageOrder.Core.CurrentUser;

namespace BPA.SAAS.KitChenManageOrder.Web.Core.Handlers
{
    public class CheckHandler
    {
        /// <summary>
        ///检查Sign
        /// </summary>
        public async Task CheckSign(string key, string signStr, string signMd5)
        {


            //检查key
            await CheckKey(key);

            //var thisSign = signStr + "&key=" + key;
            //var vvv = MD5Encryption.Encrypt(thisSign.ToUpper()).ToUpper();

            //var vvvvv = thisSign.ToUpper();

            //if (MD5Encryption.Encrypt(thisSign.ToUpper()).ToUpper() != signMd5.ToUpper())
            //{
            //    throw Oops.Oh(ErrorCodeEnum.Code1005);
            //}
        }


        /// <summary>
        /// 检查平key验证
        /// </summary>
        /// <param name="key"></param>
        private async Task CheckKey(string key)
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();
            var url = App.Configuration["SAAS_KitManage"] + "api/authorization/getstoreauthorization?key="+ key;
            var jsonData = HttpHelper.HttpGet(url, null, dic, "application/json");
            var data = JsonConvert.DeserializeObject<ResultSAASManageDto<StoreAuthorizationDto>>(jsonData);
            if (data.statusCode != 200) throw Oops.Oh(data.errors);
            if (data.data == null) throw Oops.Oh(ErrorCodeEnum.Code10023);
            await CheckTenant(data.data.GroupId);
        }

        /// <summary>
        /// 检查租户
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        private async Task CheckTenant(string tenantId)
        {

            try
            {
                Dictionary<string, string> dic = new Dictionary<string, string>();
                var url = App.Configuration["SAAS_Manage"] + "api/authorization/GetCompanyById?id=" + tenantId;
                var jsonData =await url.GetAsStringAsync();// HttpHelper.HttpGet(url, null, dic, "application/json");
                var data = JsonConvert.DeserializeObject<CompanyDto>(jsonData);
               // if (data.statusCode != 200) throw Oops.Oh(ErrorCodeEnum.Code10016);
                if (data == null) throw Oops.Oh(ErrorCodeEnum.Code10016);
                CurrentUser.GroupId = tenantId;
            }
            catch (Exception e)
            {
                throw Oops.Oh("请求错误");
            }
        }
    }
}
